--- old/usr/src/uts/common/Makefile.files	Mon Aug 27 16:56:40 2012
+++ new/usr/src/uts/common/Makefile.files	Mon Aug 27 16:56:40 2012
@@ -66,6 +66,7 @@
 		rctl_proc.o	\
 		rwlock.o	\
 		seg_kmem.o	\
+		seqlock.o	\
 		softint.o	\
 		string.o	\
 		strtol.o	\
@@ -252,6 +253,7 @@
 		pgrp.o		\
 		pgrpsys.o	\
 		pid.o		\
+		pkp_hash.o	\
 		policy.o	\
 		poll.o		\
 		pool.o		\
@@ -916,7 +918,7 @@
 
 EMLXS_OBJS +=	emlxs_clock.o emlxs_dfc.o emlxs_dhchap.o emlxs_diag.o \
 		emlxs_download.o emlxs_dump.o emlxs_els.o emlxs_event.o \
-		emlxs_fcp.o emlxs_fct.o emlxs_hba.o emlxs_ip.o \
+		emlxs_fcf.o emlxs_fcp.o emlxs_fct.o emlxs_hba.o emlxs_ip.o \
 		emlxs_mbox.o emlxs_mem.o emlxs_msg.o emlxs_node.o \
 		emlxs_pkt.o emlxs_sli3.o emlxs_sli4.o emlxs_solaris.o \
 		emlxs_thread.o
@@ -951,7 +953,7 @@
 
 STMF_OBJS += lun_map.o stmf.o
 
-STMF_SBD_OBJS += sbd.o sbd_scsi.o sbd_pgr.o
+STMF_SBD_OBJS += sbd.o sbd_scsi.o sbd_pgr.o sbd_zvol.o ats_copy_mgr.o
 
 SYSMSG_OBJS +=	sysmsg.o
 
@@ -1024,7 +1026,7 @@
 FP_OBJS += fp.o
 
 QLC_OBJS += ql_api.o ql_debug.o ql_hba_fru.o ql_init.o ql_iocb.o ql_ioctl.o \
-	ql_isr.o ql_mbx.o ql_xioctl.o ql_fw_table.o
+	ql_isr.o ql_mbx.o ql_nx.o ql_xioctl.o ql_fw_table.o
 
 QLC_FW_2200_OBJS += ql_fw_2200.o
 
@@ -1153,15 +1155,13 @@
 		smb_oem.o \
 		smb_string.o \
 		smb_utf8.o \
-		smb_common_door_decode.o \
-		smb_xdr_utils.o \
+		smb_door_legacy.o \
+		smb_xdr.o \
 		smb_token.o \
 		smb_token_xdr.o \
 		smb_sid.o \
-		smb_status_xlat.o \
 		smb_native.o \
-		smb_netbios_util.o \
-		smb_share_door_decode.o
+		smb_netbios_util.o
 
 SMBSRV_OBJS +=	$(SMBSRV_SHARED_OBJS)			\
 		smb_acl.o				\
@@ -1177,11 +1177,12 @@
 		smb_fem.o				\
 		smb_find.o				\
 		smb_flush.o				\
+		smb_fsinfo.o				\
 		smb_fsops.o				\
 		smb_init.o				\
-		smb_kdoor_encdec.o			\
-		smb_kdoor_clnt.o			\
+		smb_kdoor.o				\
 		smb_kshare.o				\
+                smb_kutil.o				\
 		smb_lock.o				\
 		smb_lock_byte_range.o			\
 		smb_locking_andx.o			\
@@ -1197,6 +1198,7 @@
                 smb_nt_transact_create.o		\
 		smb_nt_transact_ioctl.o			\
 		smb_nt_transact_notify_change.o		\
+		smb_nt_transact_quota.o			\
 		smb_nt_transact_security.o		\
                 smb_odir.o				\
 		smb_ofile.o				\
@@ -1207,7 +1209,6 @@
 		smb_print.o				\
 		smb_process_exit.o			\
 		smb_query_fileinfo.o			\
-		smb_query_information_disk.o		\
 		smb_read.o				\
 		smb_rename.o				\
 		smb_sd.o				\
@@ -1221,18 +1222,14 @@
 		smb_trans2_create_directory.o		\
 		smb_trans2_dfs.o			\
 		smb_trans2_find.o			\
-		smb_trans2_query_fs_information.o	\
 		smb_tree_connect.o			\
 		smb_unlock_byte_range.o			\
-		smb_upcalls.o				\
 		smb_user.o				\
-                smb_util.o				\
 		smb_vfs.o				\
 		smb_vops.o				\
 		smb_vss.o				\
 		smb_write.o				\
-		smb_write_raw.o				\
-		smb_xlate.o
+		smb_write_raw.o
 
 PCFS_OBJS +=	pc_alloc.o	pc_dir.o	pc_node.o	pc_subr.o \
 		pc_vfsops.o	pc_vnops.o
@@ -1310,10 +1307,12 @@
 ZFS_COMMON_OBJS +=		\
 	arc.o			\
 	bplist.o		\
+	bpobj.o			\
 	dbuf.o			\
 	ddt.o			\
 	ddt_zap.o		\
 	dmu.o			\
+	dmu_diff.o		\
 	dmu_send.o		\
 	dmu_object.o		\
 	dmu_objset.o		\
@@ -1323,16 +1322,18 @@
 	dnode_sync.o		\
 	dsl_dir.o		\
 	dsl_dataset.o		\
+	dsl_deadlist.o		\
 	dsl_pool.o		\
 	dsl_synctask.o		\
 	dmu_zfetch.o		\
 	dsl_deleg.o		\
 	dsl_prop.o		\
-	dsl_scrub.o		\
+	dsl_scan.o		\
 	gzip.o			\
 	lzjb.o			\
 	metaslab.o		\
 	refcount.o		\
+	sa.o			\
 	sha256.o		\
 	spa.o			\
 	spa_config.o		\
@@ -1356,8 +1357,10 @@
 	zap_leaf.o		\
 	zap_micro.o		\
 	zfs_byteswap.o		\
+	zfs_debug.o		\
 	zfs_fm.o		\
 	zfs_fuid.o		\
+	zfs_sa.o		\
 	zfs_znode.o		\
 	zil.o			\
 	zio.o			\
@@ -1364,7 +1367,8 @@
 	zio_checksum.o		\
 	zio_compress.o		\
 	zio_inject.o		\
-	zle.o
+	zle.o			\
+	zrlock.o
 
 ZFS_SHARED_OBJS +=		\
 	zfs_namecheck.o		\
@@ -1384,6 +1388,7 @@
 	zfs_dir.o		\
 	zfs_ioctl.o		\
 	zfs_log.o		\
+	zfs_onexit.o		\
 	zfs_replay.o		\
 	zfs_rlock.o		\
 	rrwlock.o		\
@@ -1786,7 +1791,7 @@
 
 MXFE_OBJS += mxfe.o
 
-MPTSAS_OBJS += mptsas.o mptsas_impl.o mptsas_init.o mptsas_raid.o
+MPTSAS_OBJS += mptsas.o mptsas_impl.o mptsas_init.o mptsas_raid.o mptsas_smhba.o
 
 SFE_OBJS += sfe.o sfe_util.o
 
--- /dev/null	Mon Aug 27 16:56:41 2012
+++ new/usr/src/uts/common/os/seqlock.c	Mon Aug 27 16:56:41 2012
@@ -0,0 +1,66 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+/*
+ * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ *
+ * seqlock.c - Implementation of sequence lock algorithm.
+ */
+#include <sys/types.h>
+#include <sys/ddi.h>
+#include <sys/mutex.h>
+#include <sys/cpu.h>		/* for SMT_PAUSE */
+#include <sys/cpuvar.h>		/* for kpreempt */
+#include <sys/seqlock.h>
+
+void
+seq_init(seqlock_t *seqlock)
+{
+	seqlock->sequence = 0;
+	mutex_init(&seqlock->lock, NULL, MUTEX_DEFAULT, NULL);
+}
+
+void
+seq_destroy(seqlock_t *seqlock)
+{
+	mutex_destroy(&seqlock->lock);
+}
+
+int
+seq_read_begin(volatile seqlock_t *seqlock)
+{
+	int seq;
+again:
+	seq = seqlock->sequence;
+	if (seq & 0x1) {
+		SMT_PAUSE();
+		goto again;
+	}
+	membar_consumer();
+	return (seq);
+}
+
+void
+seq_write_lock(seqlock_t *seqlock)
+{
+	mutex_enter(&seqlock->lock);
+	kpreempt_disable();
+	seqlock->sequence++;
+	membar_producer();
+}
+
+void
+seq_write_unlock(seqlock_t *seqlock)
+{
+	seqlock->sequence++;
+	membar_producer();
+	kpreempt_enable();
+	mutex_exit(&seqlock->lock);
+}
--- /dev/null	Mon Aug 27 16:56:42 2012
+++ new/usr/src/uts/common/sys/seqlock.h	Mon Aug 27 16:56:42 2012
@@ -0,0 +1,63 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+/*
+ * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
+ *
+ * seqlock.h - Definitions of sequence lock algorithm.
+ *
+ * Example for reader:
+ *
+ * do {
+ *    int seq = seq_read_begin(&seqlock);
+ *    ...
+ * } while (seq_read_retry(&seqlock, seq));
+ *
+ */
+
+#ifndef	_SYS_SEQLOCK_H
+#define	_SYS_SEQLOCK_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+#include <sys/types.h>
+#include <sys/mutex.h>
+#include <sys/atomic.h>		/* for membar_consumer() */
+
+typedef struct seqlock {
+	int	 sequence;
+	kmutex_t lock;
+} seqlock_t;
+
+extern void seq_init(seqlock_t *);
+extern void seq_destroy(seqlock_t *);
+extern int  seq_read_begin(volatile seqlock_t *);
+
+/*
+ * Code under seq_write_lock() should be fast and
+ * must not call sleeping function
+ */
+extern void seq_write_lock(seqlock_t *);
+extern void seq_write_unlock(seqlock_t *);
+
+static boolean_t seq_read_retry(const seqlock_t *seqlock, int seq)
+{
+	membar_consumer();
+	return (seqlock->sequence != seq);
+}
+#pragma inline(seq_read_retry)
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _SYS_SEQLOCK_H */
